(function(g,f){typeof exports==='object'&&typeof module!=='undefined'?f(exports):typeof define==='function'&&define.amd?define(['exports'],f):(g=g||self,f(g.$sv={}));}(this,function(exports){'use strict';const addListener = (function () {
    if (typeof window === 'undefined')
        return function () { };
    if (!window.addEventListener) {
        return function (event, fn, dom) {
            const eventDOM = dom || window;
            eventDOM.attachEvent(`on${event}`, fn);
        };
    }
    return function (event, fn, dom, option = {}) {
        const eventDOM = dom || window;
        const { capture = false, passive = false, once = false } = option;
        eventDOM.addEventListener(event, fn, {
            capture,
            passive,
            once
        });
    };
})();const removeListener = (function () {
    if (typeof window === 'undefined')
        return function () { };
    if (!window.removeEventListener) {
        return function (event, fn, dom) {
            const eventDOM = dom || window;
            eventDOM.detachEvent(`on${event}`, fn);
        };
    }
    return function (event, fn, dom, useCapture = false) {
        const eventDOM = dom || window;
        eventDOM.removeEventListener(event, fn, useCapture);
    };
})();function isType(type) {
    return function (ele) {
        if (typeof ele !== 'object')
            return typeof ele === type.toLowerCase();
        const len = Object.prototype.toString.call(ele).length - 1;
        return Object.prototype.toString.call(ele).slice(8, len).toLowerCase() === type.toLowerCase();
    };
}function notSupport() {
    console.warn('Your browser not support the [Performance] API!');
    return false;
}
function notSupportPromisify() {
    console.warn('Your browser not support the [Performance] API!');
    return Promise.resolve(false);
}const longTaskThreshold = 50;
const singleTaskThreshold = longTaskThreshold / 2;
const notGF = function () {
    console.warn('Please pass the [Generator Function]');
    return false;
};
const timeslice = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function (genF) {
        if (!genF || typeof genF !== 'function')
            return notGF;
        const gen = genF();
        if (typeof gen.next !== 'function')
            return notGF;
        return new Promise((resolve, reject) => {
            function next() {
                try {
                    const start = performance.now();
                    let res = null;
                    do {
                        res = gen.next();
                    } while (!res.done && performance.now() - start < singleTaskThreshold);
                    if (res.done) {
                        resolve(res.value);
                        return;
                    }
                    setTimeout(next);
                }
                catch (err) {
                    reject(err);
                }
            }
            next();
        });
    };
})();const parseUrl = (function () {
    if (typeof window === 'undefined')
        return;
    const HTTP_PORT = '80';
    const HTTPS_PORT = '443';
    const DEFAULT_PORT = RegExp(':(' + HTTP_PORT + '|' + HTTPS_PORT + ')$');
    const a = document.createElement('a');
    const cache = {};
    return function parse_url(url) {
        url = (!url || url == '.') ? location.href : url;
        if (cache[url])
            return cache[url];
        a.href = url;
        if (url.charAt(0) == '.' || url.charAt(0) == '/')
            return parse_url(a.href);
        let port = (a.port == HTTP_PORT || a.port == HTTPS_PORT) ? '' : a.port;
        port = port == '0' ? '' : port;
        const host = a.host.replace(DEFAULT_PORT, '');
        const origin = a.origin ? a.origin : a.protocol + '//' + host;
        const pathname = a.pathname.charAt(0) == '/' ? a.pathname : '/' + a.pathname;
        return cache[url] = {
            hash: a.hash,
            host: host,
            hostname: a.hostname,
            href: a.href,
            origin: origin,
            pathname: pathname,
            port: port,
            protocol: a.protocol,
            search: a.search,
        };
    };
})();const storage = (function () {
    if (typeof window === 'undefined' || !window.sessionStorage || !window.localStorage)
        return {
            get: () => null,
            set: () => false,
            clear: () => false
        };
    const handleStorage = {
        sessionStorage: {
            set(key, val) {
                let res;
                try {
                    window.sessionStorage.setItem(key, val);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            },
            get(key) {
                let res;
                try {
                    res = window.sessionStorage.getItem(key);
                }
                catch (err) {
                    res = null;
                }
                return res;
            },
            clear(key) {
                let res;
                try {
                    window.sessionStorage.removeItem(key);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            }
        },
        localStorage: {
            set(key, val) {
                let res;
                try {
                    window.localStorage.setItem(key, val);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            },
            get(key) {
                let res;
                try {
                    res = window.localStorage.getItem(key);
                }
                catch (err) {
                    res = null;
                }
                return res;
            },
            clear(key) {
                let res;
                try {
                    window.localStorage.removeItem(key);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            }
        },
        cookie: {
            set(key, val, option) {
                let res;
                try {
                    let { domain = '', path = '/', expires = 0, secure = false } = option || {};
                    let ts;
                    if (expires >= 0) {
                        ts = new Date();
                        ts.setTime(ts.getTime() + expires * 1000);
                    }
                    document.cookie = `${key}=${val};domain=${domain};path=${path};expires=${ts ? ts.toUTCString() : ''};${secure ? 'secure' : ''}`;
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            },
            get(key) {
                const reg = new RegExp('(^| )' + key + '=([^;]*)(;|$)');
                const cookArr = document.cookie.match(reg);
                if (cookArr && cookArr[2]) {
                    return unescape(cookArr[2]);
                }
                return null;
            },
            clear(key, domain) {
                document.cookie = `${key}="";domain=${domain};max-age=-1`;
                const res = handleStorage.cookie.get(key);
                return !!res;
            }
        },
        get(key, storeType) {
            try {
                if (typeof storeType === 'string' && handleStorage[storeType]) {
                    return handleStorage[storeType].get(key);
                }
                return this.cookie.get(key) || this.localStorage.get(key) || this.sessionStorage.get(key);
            }
            catch (e) {
                return null;
            }
        },
        set(key, val, storeType, option) {
            let res;
            try {
                if (typeof storeType === 'string' && handleStorage[storeType]) {
                    res = handleStorage[storeType].set(key, val, option);
                }
                else if (option) {
                    res = handleStorage.cookie.set(key, val, option);
                }
                else {
                    res = handleStorage.localStorage.set(key, val);
                }
            }
            catch (e) {
                res = false;
            }
            return res;
        },
        clear(key, storeType, domain) {
            let res;
            try {
                if (typeof storeType === 'string' && handleStorage[storeType]) {
                    res = handleStorage[storeType].clear(key, domain);
                }
                else if (domain) {
                    res = handleStorage.cookie.clear(key, domain);
                }
                else {
                    res = handleStorage.localStorage.clear(key) && handleStorage.sessionStorage.clear(key);
                }
            }
            catch (e) {
                res = false;
            }
            return res;
        }
    };
    return handleStorage;
})();function uuid() {
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }
    return (S4() + S4() + '-' + S4() + '-' + S4() + '-' + S4() + '-' + S4() + S4() + S4());
}class Observer {
    constructor(target, callback) {
        this.cache = [];
        this.observer = this.init(target, callback);
    }
    init(target, callback) {
        if (!target) {
            console.warn('Please pass a vaild HTMLElement');
            return null;
        }
        let observer;
        try {
            observer = new MutationObserver(callback);
            observer.observe(target, {
                'childList': true,
                'subtree': true,
                'attributes': true,
                'attributeFilter': ['src', 'href']
            });
        }
        catch (error) {
            return null;
        }
        return observer;
    }
    cancel() {
        this.observer && this.observer.disconnect();
    }
    setCache(cache) {
        this.cache.push(cache);
    }
    getCache() {
        return this.cache;
    }
    clearCache() {
        this.cache.splice(0);
    }
}var ExceptionTypes;
(function (ExceptionTypes) {
    ExceptionTypes[ExceptionTypes["js"] = 0] = "js";
    ExceptionTypes[ExceptionTypes["api"] = 1] = "api";
    ExceptionTypes[ExceptionTypes["source"] = 2] = "source";
})(ExceptionTypes || (ExceptionTypes = {}));
const jsErrors = [];
const apiErrors = [];
const sourceErrors = [];
const errorTag = 'fe-supervisor-error';
const HandleException = {
    getErrors(type) {
        const typeIndex = type ? ExceptionTypes[type] : undefined;
        let errors;
        switch (typeIndex) {
            case ExceptionTypes['js']:
                errors = jsErrors;
                break;
            case ExceptionTypes['api']:
                errors = apiErrors;
                break;
            case ExceptionTypes['source']:
                errors = sourceErrors;
                break;
            default:
                errors = { jsErrors, apiErrors, sourceErrors };
        }
        return errors;
    },
    setErrors(error) {
        const { type } = error;
        const typeIndex = ExceptionTypes[type];
        switch (typeIndex) {
            case ExceptionTypes['js']:
                jsErrors.push(error);
                break;
            case ExceptionTypes['api']:
                apiErrors.push(error);
                break;
            case ExceptionTypes['source']:
                sourceErrors.push(error);
                break;
        }
    },
    clearError(type) {
        const typeIndex = type ? ExceptionTypes[type] : undefined;
        let res = true;
        try {
            switch (typeIndex) {
                case ExceptionTypes['js']:
                    jsErrors.splice(0);
                    break;
                case ExceptionTypes['api']:
                    apiErrors.splice(0);
                    break;
                case ExceptionTypes['source']:
                    sourceErrors.splice(0);
                    break;
                default:
                    jsErrors.splice(0);
                    apiErrors.splice(0);
                    sourceErrors.splice(0);
            }
        }
        catch (err) {
            res = false;
        }
        return res;
    }
};const getMemory = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function () {
        let used, total, usedRatio;
        try {
            const p = window.performance;
            const m = p.memory || {};
            used = m.usedJSHeapSize || 0;
            total = m.totalJSHeapSize || 1;
            usedRatio = +Number.prototype.toFixed.call(used / total, 3);
        }
        catch (error) {
            HandleException.setErrors({
                ts: +Date.now(),
                type: 'js',
                url: location.href,
                msg: `[SV - getMemory]: ${JSON.stringify(error)}`
            });
        }
        finally {
            return {
                memory: usedRatio || 'N/A',
                used: used || 'N/A',
                total: total || 'N/A'
            };
        }
    };
})();
const getTiming = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function () {
        let wscreen, fscreen, network, network_prev, network_redirect, network_dns, network_tcp, network_request, render_ready, render_load, js_complete, dom_complete, total;
        wscreen = fscreen = network = network_prev = network_redirect = network_dns = network_tcp = network_request = render_ready = render_load = js_complete = dom_complete = total = 'N/A';
        try {
            const p = window.performance;
            const t = p.timing || {};
            wscreen = timingFilter(t.responseStart - t.navigationStart);
            fscreen = timingFilter(t.domContentLoadedEventStart - t.navigationStart);
            network = timingFilter(t.responseEnd - t.navigationStart);
            network_prev = timingFilter(t.fetchStart - t.navigationStart);
            network_redirect = timingFilter(t.redirectEnd - t.redirectStart);
            network_dns = timingFilter(t.domainLookupEnd - t.domainLookupStart);
            network_tcp = timingFilter(t.connectEnd - t.connectStart);
            network_request = timingFilter(t.responseEnd - t.requestStart);
            render_ready = timingFilter(t.domContentLoadedEventStart - t.domLoading);
            render_load = timingFilter(t.loadEventEnd - t.domLoading);
            js_complete = timingFilter(t.domContentLoadedEventEnd - t.navigationStart);
            dom_complete = timingFilter(t.domComplete - t.navigationStart);
            total = timingFilter(t.loadEventEnd - t.navigationStart);
        }
        catch (error) {
            HandleException.setErrors({
                ts: +Date.now(),
                type: 'js',
                url: location.href,
                msg: `[SV - getTiming]: ${JSON.stringify(error)}`
            });
        }
        finally {
            return {
                wscreen,
                fscreen,
                network,
                network_prev,
                network_redirect,
                network_dns,
                network_tcp,
                network_request,
                render_ready,
                render_load,
                js_complete,
                dom_complete,
                total
            };
        }
    };
})();
const getSource = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupportPromisify;
    return async function (config) {
        const api_random = [];
        const api_timeout = [];
        const api_appoint = [];
        const source_random = [];
        const source_timeout = [];
        const source_appoint = [];
        try {
            const { apiRatio = 0.1, sourceRatio = 0.1, apis = '', sources = '', timeout = 2000, whitelist = {} } = config || {};
            const w_a = whitelist.api || '';
            const w_s = whitelist.source || '';
            const p = window.performance;
            const s = (p.getEntriesByType && p.getEntriesByType('resource')) || (p.getEntries && p.getEntries()) || [];
            const threshold = timeout;
            function* gen() {
                const len = s.length;
                for (let i = 0; i < len; i++) {
                    const item = s[i];
                    const type = item.initiatorType || '';
                    const data = {
                        name: item.name,
                        duration: +Number.prototype.toFixed.call(item.duration, 2),
                        type
                    };
                    if (type === 'xmlhttprequest' || type === 'fetchrequest') {
                        if (w_a) {
                            if (isType('string')(w_a)) {
                                if (data.name === w_a)
                                    break;
                            }
                            else if (isType('array')(w_a)) {
                                const w_a_len = w_a.length;
                                for (let j = 0; j < w_a_len; j++) {
                                    if (data.name === w_a[j])
                                        break;
                                }
                            }
                        }
                        randomRatio(apiRatio) && api_random.push(data);
                        data.duration >= threshold && api_timeout.push(data);
                        if (isType('string')(apis)) {
                            data.name === apis && api_appoint.push(data);
                        }
                        else if (isType('array')(apis)) {
                            apis.some(v => {
                                if (v === data.name) {
                                    api_appoint.push(data);
                                    return true;
                                }
                                return false;
                            });
                        }
                    }
                    else if (type === 'script' || type === 'css' || type === 'img' || type === 'link') {
                        if (w_s) {
                            if (isType('string')(w_s)) {
                                if (data.name === w_s)
                                    break;
                            }
                            else if (isType('array')(w_s)) {
                                const w_s_len = w_s.length;
                                for (let m = 0; m < w_s_len; m++) {
                                    if (data.name === w_s[m])
                                        break;
                                }
                            }
                        }
                        randomRatio(sourceRatio) && source_random.push(data);
                        data.duration >= threshold && source_timeout.push(data);
                        if (isType('string')(sources)) {
                            type === sources && source_appoint.push(data);
                        }
                        else if (isType('array')(sources)) {
                            sources.some(v => {
                                if (v === type) {
                                    source_appoint.push(data);
                                    return true;
                                }
                                return false;
                            });
                        }
                        else if (isType('object')(sources)) {
                            for (const k in sources) {
                                if (k === type) {
                                    sources[k].some(v => {
                                        if (v === data.name) {
                                            source_appoint.push(data);
                                            return true;
                                        }
                                        return false;
                                    });
                                }
                            }
                        }
                    }
                    yield;
                }
            }
            await timeslice(gen);
        }
        catch (error) {
            HandleException.setErrors({
                ts: +Date.now(),
                type: 'js',
                url: location.href,
                msg: `[SV - getSource]: ${JSON.stringify(error)}`
            });
        }
        finally {
            return {
                api_random,
                api_timeout,
                api_appoint,
                source_random,
                source_timeout,
                source_appoint
            };
        }
    };
})();
const getExecTiming = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupportPromisify;
    return async function () {
        const exec = [];
        try {
            const p = window.performance;
            let measures = [];
            if (p.mark && p.measure) {
                measures = (p.getEntriesByType && p.getEntriesByType('measure')) || (p.getEntries && p.getEntries()) || [];
            }
            else {
                measures = measureCache;
            }
            function* gen() {
                const len = measures.length;
                for (let i = 0; i < len; i++) {
                    const item = measures[i];
                    if (item.entryType === 'measure') {
                        exec.push({
                            name: item.name,
                            duration: +Number.prototype.toFixed.call(item.duration, 3)
                        });
                    }
                }
                yield;
            }
            await timeslice(gen);
        }
        catch (error) {
            HandleException.setErrors({
                ts: +Date.now(),
                type: 'js',
                url: location.href,
                msg: `[SV - getExecTiming]: ${JSON.stringify(error)}`
            });
        }
        finally {
            return {
                exec
            };
        }
    };
})();
const getPerformanceData = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupportPromisify;
    return async function (config) {
        let memory, timings, sources, execTiming;
        try {
            const memo = getMemory();
            memory = memo && memo.memory;
            timings = getTiming() || {};
            sources = await getSource(config).then(data => data);
            execTiming = await getExecTiming().then(data => data);
        }
        catch (error) {
            HandleException.setErrors({
                ts: +Date.now(),
                type: 'js',
                url: location.href,
                msg: `[SV - getPerformanceData]: ${JSON.stringify(error)}`
            });
        }
        finally {
            return {
                memory: memory || 'N/A',
                ...timings,
                ...sources,
                ...execTiming
            };
        }
    };
})();
const markCache = [];
const measureCache = [];
function compatibleMark(tag) {
    const ts = +((window.performance.now && ('' + window.performance.now())) || Date.now());
    markCache.push({ tag, ts });
}
function compatibleMeasure(tag, tagStart, tagEnd) {
    const len = markCache.length;
    let startTime = 0;
    let endTime = 0;
    for (let i = 0; i < len; i++) {
        const item = markCache[i];
        if (item.tag === tagStart)
            startTime = item.ts;
        if (item.tag === tagEnd)
            endTime = item.ts;
    }
    measureCache.push({ entryType: 'measure', name: tag, duration: Math.abs(endTime - startTime) });
}
const marks = [];
const measures = [];
const mark = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function (tag) {
        let res = true;
        try {
            const p = window.performance;
            const tagS = `${tag}_start`;
            const tagE = `${tag}_end`;
            if (!~marks.indexOf(tag)) {
                if (p.mark) {
                    p.mark(tagS);
                }
                else {
                    compatibleMark(tagS);
                }
                marks.push(tag);
            }
            else if (!~measures.indexOf(tag)) {
                if (p.mark && p.measure) {
                    p.mark(tagE);
                    p.measure(`${tag}`, tagS, tagE);
                }
                else {
                    compatibleMark(tagE);
                    compatibleMeasure(`${tag}`, tagS, tagE);
                }
                measures.push(tag);
            }
            else {
                res = false;
                console.warn(`Cannot repeat tag the mark: ${tag}`);
            }
        }
        catch (error) {
            res = false;
            HandleException.setErrors({
                ts: +Date.now(),
                type: 'js',
                url: location.href,
                msg: `[SV - mark]: ${JSON.stringify(error)}`
            });
        }
        finally {
            return res;
        }
    };
})();
const clearPerformance = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function (clearType) {
        try {
            const isClearSource = !clearType || clearType === 'source' || clearType === 'all';
            const isClearMark = !clearType || clearType === 'mark' || clearType === 'all';
            const isClearMeasure = !clearType || clearType === 'measure' || clearType === 'all';
            const p = window.performance;
            if (isClearMark) {
                p.clearMarks && p.clearMarks();
                marks.splice(0);
                markCache.splice(0);
            }
            if (isClearMeasure) {
                p.clearMeasures && p.clearMeasures();
                measures.splice(0);
                measureCache.splice(0);
            }
            isClearSource && p.clearResourceTimings && p.clearResourceTimings();
            return true;
        }
        catch (error) {
            HandleException.setErrors({
                ts: +Date.now(),
                type: 'js',
                url: location.href,
                msg: `[SV - clearPerformance]: ${JSON.stringify(error)}`
            });
            return false;
        }
    };
})();
const observeSource = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupportPromisify;
    return function (target, callback, option) {
        let { sourceType = 'img', timeout = 2000, whitelist = {} } = option || {};
        sourceType = sourceType.toLowerCase();
        getSourceByDom(target);
        const observer = new Observer(target, async function (mutationRecords) {
            let spendTime = 0;
            let frequence = 200;
            const len = mutationRecords.length;
            const sourceAddr = [];
            for (let i = 0; i < len; i++) {
                const item = mutationRecords[i];
                const recordType = mutationRecords[i].type;
                switch (recordType) {
                    case 'childList':
                        const addNodes = item.addedNodes;
                        await timeslice(iterationDOM(addNodes, sourceAddr));
                        break;
                    case 'attributes':
                        const attrName = item.attributeName;
                        const target = item.target;
                        attrName && sourceAddr.push(target[attrName]);
                        break;
                }
            }
            timerQuery();
            function timerQuery() {
                setTimeout(async function () {
                    const sourceData = await getSource({
                        apiRatio: 0,
                        sourceRatio: 0,
                        sources: { [`${sourceType}`]: sourceAddr },
                        whitelist
                    }).then(data => data.source_appoint);
                    if (sourceData.length === sourceAddr.length || spendTime >= timeout) {
                        return callback && callback(sourceData);
                    }
                    else {
                        spendTime += frequence;
                        timerQuery();
                    }
                }, frequence);
            }
        });
        async function getSourceByDom(dom, isAsync) {
            let data = [];
            try {
                const sourceAddr = [];
                if (dom.nodeName.toLowerCase() === sourceType) {
                    const sourceSrc = dom.src || dom.href || '';
                    sourceSrc && sourceAddr.push(sourceSrc);
                }
                const doms = dom.children;
                if (doms && doms.length > 0) {
                    await timeslice(iterationDOM(doms, sourceAddr));
                }
                data = await getSource({
                    apiRatio: 0,
                    sourceRatio: 0,
                    sources: { [`${sourceType}`]: sourceAddr },
                    whitelist
                }).then(data => data.source_appoint);
                !isAsync && callback && callback(data);
            }
            catch (error) {
                HandleException.setErrors({
                    ts: +Date.now(),
                    type: 'js',
                    url: location.href,
                    msg: `[SV - observeSource_getSourceByDom]: ${JSON.stringify(error)}`
                });
            }
            finally {
                return data;
            }
        }
        function iterationDOM(doms, sourceAddr) {
            return function* () {
                try {
                    const len = doms.length;
                    for (let i = 0; i < len; i++) {
                        const dom = doms[i];
                        const type = dom.nodeName.toLowerCase();
                        if (sourceType === type) {
                            const sourceSrc = dom.src || dom.href || '';
                            sourceSrc && sourceAddr.push(sourceSrc);
                        }
                        const children = dom.children;
                        const childLen = children ? children.length : 0;
                        if (childLen > 0) {
                            yield timeslice(iterationDOM(children, sourceAddr));
                        }
                        yield;
                    }
                }
                catch (error) {
                    HandleException.setErrors({
                        ts: +Date.now(),
                        type: 'js',
                        url: location.href,
                        msg: `[SV - observeSource_iterationDOM]: ${JSON.stringify(error)}`
                    });
                }
            };
        }
        return observer;
    };
})();
function timingFilter(timing) {
    if (timing === null || isNaN(timing))
        return 'N/A';
    return timing > 0 ? timing : 0;
}
function randomRatio(ratio) {
    if (ratio === 0)
        return false;
    if (Math.random() <= ratio)
        return true;
    return false;
}
class SV {
    constructor(config) {
        this.config = config;
    }
    updateConfig(newConfig) {
        this.config = { ...this.config, ...newConfig };
    }
    getMemory() {
        return getMemory();
    }
    getTiming() {
        return getTiming();
    }
    async getSource() {
        return await getSource(this.config);
    }
    async getExecTiming() {
        return await getExecTiming();
    }
    async getPerformanceData() {
        return getPerformanceData(this.config);
    }
    clearPerformance(clearType) {
        return clearPerformance(clearType);
    }
    observeSource(target, callback, option) {
        if (this.config && this.config.timeout) {
            option = { timeout: this.config.timeout, ...option };
        }
        return observeSource(target, callback, option);
    }
}const getEnvInfo = (function () {
    if (typeof window === 'undefined')
        return function () {
            console.warn('Please call in browser environment');
            return false;
        };
    return function () {
        const ua = navigator.userAgent;
        const scr = window.screen;
        const page_url = location.href;
        const referer = document.referrer;
        const info = {
            ts: +Date.now(),
            os: '',
            browser: '',
            screen_size: (scr.width || 0) + 'x' + (scr.height || 0),
            page_url,
            referer,
            device: ('ontouchstart' in window ? 'mobile' : 'pc'),
            ua
        };
        function check(pattern) {
            return function () {
                return (pattern).test(ua);
            };
        }
        const UA = {
            isAndroid: check(/android/i),
            isIOS: check(/(ipad|iphone|ipod)/i),
            isWindows: check(/window/i),
            isMac: check(/mac os x/i),
            isChrome: check(/webkit\W.*(chrome|chromium)\W/i),
            isFirefox: check(/mozilla.*\Wfirefox\W/i),
            isGecko: check(/mozilla(?!.*webkit).*\Wgecko\W/i),
            is360se: check(/360/i),
            isIE: function () {
                if (navigator.appName === 'Microsoft Internet Explorer') {
                    return true;
                }
                else if (check(/\bTrident\b/)()) {
                    return true;
                }
                else {
                    return false;
                }
            },
            isEdge: check(/\bEdge\b/i),
            isOpera: check(/opera.*\Wpresto\W|OPR/i),
            isSafari: check(/webkit\W(?!.*chrome).*safari\W/i),
            isUCBrowser: check(/ucbrowser/i),
            isBaiduBrowser: check(/bidubrowser/i),
            isSougouBrowser: check(/metasr/i),
            isLiebaoBrowser: check(/lbbrowser/i),
            isMobile: check(/(iphone|ipod|((?:android)?.*?mobile)|blackberry|nokia)/i),
            isWebKit: check(/webkit\W/i),
            isWeixin: check(/micromessenger/i),
            isSinaWeibo: check(/weibo/i),
            isQQ: check(/qq/i),
            isQQWeibo: check(/tencentmicroblog/i),
            isFacebook: check(/fban/i),
            isTwitter: check(/twitter/i),
            isInstagram: check(/instagram/i),
        };
        if (UA.isMobile()) {
            if (UA.isAndroid()) {
                info.os = 'android';
            }
            else if (UA.isIOS()) {
                info.os = 'ios';
            }
        }
        else {
            if (UA.isWindows()) {
                info.os = 'windows';
            }
            else if (UA.isMac()) {
                info.os = 'mac';
            }
        }
        if (UA.isWeixin()) {
            info.browser = 'weixin';
        }
        else if (UA.isSinaWeibo()) {
            info.browser = 'weibo_sina';
        }
        else if (UA.isQQWeibo()) {
            info.browser = 'weibo_qq';
        }
        else if (UA.isFacebook()) {
            info.browser = 'facebook';
        }
        else if (UA.isTwitter()) {
            info.browser = 'twitter';
        }
        else if (UA.isInstagram()) {
            info.browser = 'instagram';
        }
        else if (UA.isChrome()) {
            info.browser = 'chrome';
        }
        else if (UA.isFirefox() || UA.isGecko()) {
            info.browser = 'firefox';
        }
        else if (UA.isIE()) {
            info.browser = 'ie';
        }
        else if (UA.isEdge()) {
            info.browser = 'edge';
        }
        else if (UA.isOpera()) {
            info.browser = 'opera';
        }
        else if (UA.isSafari()) {
            info.browser = 'safari';
        }
        else if (UA.is360se()) {
            info.browser = '360';
        }
        else if (UA.isQQ()) {
            info.browser = 'qq';
        }
        else if (UA.isUCBrowser()) {
            info.browser = 'uc';
        }
        else if (UA.isBaiduBrowser()) {
            info.browser = 'baidu';
        }
        else if (UA.isSougouBrowser()) {
            info.browser = 'sougou';
        }
        else if (UA.isLiebaoBrowser()) {
            info.browser = 'liebao';
        }
        else if (UA.isWebKit()) {
            info.browser = 'webkit';
        }
        return info;
    };
})();(function () {
    if (typeof window === 'undefined')
        return;
    addListener('error', function (e) {
        const { filename, message, error } = e;
        HandleException.setErrors({
            ts: +Date.now(),
            type: 'js',
            url: filename || '',
            msg: message,
            error
        });
    }, window, { passive: true });
    addListener('DOMContentLoaded', function () {
        const imgs = transArray(document.getElementsByTagName('img'));
        const links = transArray(document.getElementsByTagName('link'));
        const scripts = transArray(document.getElementsByTagName('script'));
        const max_len = (imgs.length, links.length, scripts.length);
        for (let i = 0; i < max_len; i++) {
            imgs[i] && handleError(imgs[i], 'img');
            links[i] && handleError(links[i], 'link');
            scripts[i] && handleError(scripts[i], 'script');
        }
    }, window);
})();
function getError(type) {
    return HandleException.getErrors(type);
}
function setError(err) {
    HandleException.setErrors(err);
}
function clearError(type) {
    return HandleException.clearError(type);
}
function observeError(target, callback, observeDom) {
    const observer = new Observer(target, function (doms) {
        const observeList = (observeDom && typeof observeDom === 'string' ? [observeDom] : observeDom) || ['img'];
        handleError(doms);
        function handleError(doms) {
            try {
                const len = doms.length;
                for (let i = 0; i < len; i++) {
                    if (doms[i].addedNodes) {
                        const addedNodes = doms[i].addedNodes;
                        const len = doms[i].addedNodes.length;
                        for (let k = 0; k < len; k++) {
                            bindError(addedNodes[k]);
                        }
                    }
                    else {
                        bindError(doms[i]);
                    }
                }
            }
            catch (error) {
                setError({
                    ts: +Date.now(),
                    type: 'js',
                    url: location.href,
                    msg: `[SV - observeError_handleError]: ${JSON.stringify(error)}`
                });
            }
            function bindError(dom) {
                try {
                    const nodeName = dom.nodeName;
                    const sourceType = nodeName.toLowerCase();
                    bind: if (~observeList.indexOf(sourceType)) {
                        if (dom.getAttribute) {
                            if (dom.getAttribute(errorTag))
                                break bind;
                            dom.setAttribute(errorTag, 'true');
                        }
                        addListener('error', function (e) {
                            const target = e.target;
                            const url = target && (target.href || target.src) || location.href;
                            const errObj = {
                                ts: +Date.now(),
                                type: 'source',
                                sourceType,
                                url,
                                msg: JSON.stringify(e)
                            };
                            HandleException.setErrors(errObj);
                            callback && callback(dom, e);
                        }, dom, { passive: true });
                    }
                    const children = dom.children;
                    if (children && children.length > 0) {
                        return handleError(children);
                    }
                }
                catch (error) {
                    setError({
                        ts: +Date.now(),
                        type: 'js',
                        url: location.href,
                        msg: `[SV - observeError_bindError]: ${JSON.stringify(error)}`
                    });
                }
            }
        }
    });
    return observer;
}
function transArray(arrayLike) {
    if (Array.from) {
        return Array.from(arrayLike);
    }
    return Array.prototype.slice.call(arrayLike);
}
function handleError(target, sourceType) {
    if (!target || target.getAttribute(errorTag))
        return;
    target.setAttribute(errorTag, 'true');
    addListener('error', function (e) {
        const url = e.target.src || e.target.href;
        HandleException.setErrors({
            ts: +Date.now(),
            type: 'source',
            sourceType,
            url,
            msg: JSON.stringify(e)
        });
    }, target);
}function makeTrackInfo(type, info) {
    try {
        if (type === 'pv') {
            const guid = storage.get('uuid', 'cookie');
            if (!guid) {
                type = 'uv';
                storage.set('uuid', uuid(), 'cookie', { expires: 86400 });
            }
        }
    }
    catch (error) {
        setError({
            ts: +Date.now(),
            type: 'js',
            url: location.href,
            msg: `[SV - makeTrackInfo]: ${JSON.stringify(error)}`
        });
    }
    finally {
        return {
            ts: +Date.now(),
            type,
            info
        };
    }
}const Supervisor = {
    getPerformanceData,
    getMemory,
    getTiming,
    getSource,
    getExecTiming,
    mark,
    clearPerformance,
    observeSource,
    getEnvInfo,
    getError,
    setError,
    clearError,
    observeError,
    makeTrackInfo,
    SV
};exports.SV=SV;exports.clearError=clearError;exports.clearPerformance=clearPerformance;exports.default=Supervisor;exports.getEnvInfo=getEnvInfo;exports.getError=getError;exports.getExecTiming=getExecTiming;exports.getMemory=getMemory;exports.getPerformanceData=getPerformanceData;exports.getSource=getSource;exports.getTiming=getTiming;exports.makeTrackInfo=makeTrackInfo;exports.mark=mark;exports.observeError=observeError;exports.observeSource=observeSource;exports.setError=setError;Object.defineProperty(exports,'__esModule',{value:true});}));